/*
 This file is part of FleshChasmer.

    FleshChasmer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FleshChasmer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FleshChasmer.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <SDL/SDL.h>
//#include <stdlib.h>
#include "globalvar.h"
#include "gameloop.h"
#include "render.h"
#include "gameproc.h"
#include "zlext.h"

void calcfps(void)
{
    if (tickcount-tickcount2>1000)
    {
        iGameTime++;

        fps=fps_done;
        fps_done=0;
        tickcount2=tickcount;

    }

}
/*
void makedelay(void)
{
ltickcount=tickcount;
zzUint32 delta=tickcount-ltickcount;
if (delta<50) SDL_Delay(50-delta);
}
*/
void gameloop(void)
{
#if defined(CAANOO)
    zlExtInit();
#endif
    while (GameLoopEnabled)
    {

        if (GameMode==NewGameMode)
        {
            Gameprocess();

#if defined(CAANOO)
            zlExtFrame();
#endif
            Render();
            fps_done++;
        }
        else RenderFade();

#ifndef GP2X
        SDL_Delay(30);
#else

        switch (GameMode)
        {
        case GAME:
            SDL_Delay(10);
            break;
        case LOADING_EDITOR:
            SDL_Delay(40);
            break;
        case CLOSING_CREDITS:
            SDL_Delay(40);
            break;
        case LOADING_GAME:
            SDL_Delay(40);
            break;
        case MAINMENU:
            SDL_Delay(40);
            break;
        case PLAYER_NAME:
            SDL_Delay(40);
            break;
        case CHARACTERMENU:
            SDL_Delay(40);
            break;
        case EDITOR_MENU:
            SDL_Delay(30);
            break;
        case INTRO:
            SDL_Delay(30);
            break;
        case SHOP:
            SDL_Delay(30);
            break;
        case EDITOR_AI:
            SDL_Delay(40);
            break;
        case EDITOR_PALETTE:
            SDL_Delay(40);
            break;
        case EDITOR_TEXTURE:
            SDL_Delay(40);
            break;
        }

#endif
        tickcount=SDL_GetTicks();
//SDL_Delay(5);//SDL_Mixer.h wants you
        count++;
        calcfps();
    }

#if defined(CAANOO)
    zlExtShutDown();
#endif

}
