/*
 This file is part of FleshChasmer.

    FleshChasmer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FleshChasmer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FleshChasmer.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>
#include "types.h"
#include "struct.h"
//SDL Genociding Support

extern zzSint8 zl_vibro;
extern zzSint32 zl_gsensor[6];

//DELETE ME
extern zzUint16 Model_Faces;
extern zzUint16 Textured_Faces;
//DELETE ME


extern zzUint8 ipal[256][3];

extern zzUint8 interlacemode;
extern SDL_Surface *screen;
extern SDL_Joystick *joy;
//Sound SubEngine
extern int audio_rate;
extern zzUint16 audio_format;
extern int audio_channels;
extern int audio_buffers;
extern zzUint8 volume;
extern zzSint8 trackname_delay,volume_delay;
extern zzSint8 SoundMode;
extern zzUint8 ControlMode;

//extern zzUint32 musicpos[50];
extern zzUint8 Music_stack;

//extern Mix_Chunk *music[50];
//extern zzUint8 music_loaded[50];
extern Mix_Music *music;

extern Mix_Chunk *d_sound[100];

extern zzUint8 d_sound_count;
extern zzUint8 showmap;
extern zzUint8 blockmapstatus[256];

extern zzUint8 Music_Volume_Mix,Music_Volume;
extern zzSint8 Music_Fade_Count;
extern zzUint8 Music_Track,Next_Music_Track;
extern zzUint16 dialogcount,messagecount;

extern zzSint8 controlpadangle;
extern zzUint8 controlpadbutton[11];

//extern ZCONTROLPAD controlpad;
extern SDL_Joystick *USBjoy;

extern zzUint8 GameLoopEnabled;
extern zzUint8 GameMode,NewGameMode,EditorOn,fadecount;
extern zzUint8 scrbuf[76800],scrbuf0[19200];

extern zzUint8 screenborder,cscreenborder;
extern zzUint32 count;
extern zzSint8 menupos;

extern zzUint8 ControlType;
extern char s_textstring[128];
extern int l_textstring;
extern zzUint8 CradleMode;


extern zzUint32 ltickcount,tickcount,tickcount2;
extern zzUint8 fps,fps_done;


extern zzUint32 Tile_offset[256];
extern zzUint8 Tile[65536];
extern zzUint8 model_scalei[256];

extern zzSint32 matrix[16],camera[6],rcamera[6],width,height,dist,dist0,zbuffer[76800],zbuffer0[19200];
extern zzUint8 agressive_cam;

extern zzSint32 screen_x0,screen_x1,screen_y0,screen_y1,screen_cx,screen_cy;
extern zzSint32 screen0_x0,screen0_x1,screen0_y0,screen0_y1,screen0_cx,screen0_cy;

extern zzSint32 f_sin[4096],f_cos[4096],f_tan[1024];

extern zzUint8 palfade0[256],palfade1[256],palfade2[256];

extern zzSint32 fog0[160],fog1[160],fog2[160],fog3[160];

extern zzSint32 debugval0,debugval1;
extern zzUint8 cameradelay;
extern zzUint8 deathtrigger;
//Models
extern zzSint32 m_vx[32768],m_vy[32768],m_vz[32768];
extern zzUint16 f_0[4096],f_1[4096],f_2[4096];
extern zzUint8 f_c[4096];
extern zzUint16 model_f0[256],model_v0[256];
extern zzUint8 model_ani[256],model_fs[256],model_vs[256];
extern zzSint32 model_scalex[256],model_scaley[256],model_scalez[256];

extern zzSint16 proxy_cache_x,proxy_cache_y;
extern zzSint8 interface_L,interface_R;
//Monsters
extern zzUint8 playerstart_x,playerstart_y,playerstart_z,lastcamera;

extern zzUint8 CameraMode;
extern zzSint32 customcamera[6];

extern zzUint8 monster_ai_target[16],monster_flood_score[16];
extern zzUint8 monster_respawn[16];
extern zzUint32 monster_respawni[16];
extern zzUint8 monsters,monster_ingame[16];
extern zzUint8          monster_spawnx[16],monster_spawny[16],monster_spawnz[16],monster_status[16];
extern zzUint8          monster_ai_state[16],monster_ai_action[16],monster_ai_delay[16];
extern zzSint32         monster_ai_angle[16],monster_cx[16],    monster_cy[16],    monster_cz[16];
extern zzSint32         monster_x[16],     monster_y[16],     monster_z[16];
extern zzSint32         monster_ix[16],    monster_iy[16],    monster_iz[16];
extern zzSint32         monster_angle[16], monster_roomi[16],monster_radius[16], monster_speed[16];
extern zzSint32         monster_anglex[16],monster_anglez[16];


extern zzUint8  monster_pain[16],monster_warmode[16],monster_melee[16];
extern zzUint8  monster_model[16],monster_frame0[16],monster_frame1[16],monster_anim[16],monster_animcount[16];
extern zzUint16 model_mmv,model_mmf,model_mms;//For Memory Report Situation // EditorSpec
extern zzUint8  monster_action[16],monster_type[16],monster_animtag[16];
extern zzUint16  monster_pause[16],monster_actioncount[16];
extern zzUint8  monster_side[16],monster_blinkcount[16],monster_visible[16],monster_deathtrigger[16];
extern zzSint16 monster_hp[16],monster_mhp[16],monster_mn[16],monster_mv[16];
extern zzUint16 monster_ill[16],monster_hasted[16],monster_blessed[16],monster_poisoned[16],monster_confuzed[16],monster_magicarmor[16],monster_shielded[16],monster_invisible[16],monster_slowed[16],monster_charmed[16];
extern zzUint8 monster_modelcolor[16],monster_healed[16];
//
extern zzSint32 table_range[16][16],table_angle[16][16];
extern zzUint8 table_vis[16][16];
//Monster Table
extern zzUint16 t_monster_exp[32];
extern zzSint32 t_monster_radius[32];
extern zzSint32 t_monster_speed[32],t_monster_speed0[32],t_monster_speed1[32];
extern zzSint32 t_monster_attackradius[32],t_monster_height[32];
extern zzUint8  t_monster_stepsound[32];
extern zzUint8  t_monster_model[32];
extern zzUint8  t_monster_status[32];
extern zzUint8  t_monster_side[32],monster_agony[16];
extern zzUint8  t_monster_ai[32][5][8];
extern zzSint16 t_monster_hp[32][2],t_monster_mn[32],t_monster_mv[32],t_monster_mv0[32],t_monster_mv1[32];
extern char   t_monster_name[32][32];
extern zzUint16  t_monster_str[32],t_monster_int[32],t_monster_dex[32],t_monster_con[32],t_monster_wis[32],t_monster_cha[32];
extern zzUint16 t_monster_damage[32][2],t_monster_mdamage[32][2];
extern zzUint16 t_monster_armor[32],t_monster_resist[32];
extern zzUint8  t_monster_regen[32][5];

extern zzUint8  t_monster_warmodecount[32];
extern zzUint8  t_monster_meleeanim[32][3];
extern zzUint8  t_monster_meleeframecount[32];
extern zzUint8  t_monster_shootframe[32],t_monster_shoottype[32],t_monster_shootdelay[32];
extern zzUint8  t_monster_walkframe0[32];
extern zzUint8  t_monster_meleeframe0[32];
extern zzUint8  t_monster_painframe0[32];
extern zzUint8  t_monster_painframecount[32];
extern zzUint8  t_monster_meleesound[32],t_monster_painsound[32];
extern zzUint16 t_monster_shootdamage[32][2];
extern zzUint16 t_monster_meleerange[32];
extern zzUint32 t_monster_targetrange[32];
extern zzUint8  t_monster_deathtype[32];
extern zzUint8  t_monster_maxagonycount[32];
extern zzUint8  t_monster_deathframe[32];
extern zzUint8  t_monster_castframe0[32];
extern zzUint8  t_monster_deathspeed[32];
extern zzUint8  t_monster_action[32][5];
extern zzUint8  t_monster_simpleanim[32];
extern zzUint8  t_monster_damageeffect[32];
extern zzUint8 t_monster_deathsound[32];
extern zzUint8 t_monster_loot[32][3][3];
extern zzUint8  t_monster_char[32][2];

//
extern zzUint8 STATUS_ALIVE,STATUS_FLOATING,STATUS_TANK,STATUS_BOSS,STATUS_WORM,STATUS_UNDEAD,STATUS_CRAWLING,STATUS_AI;

//Indicators
extern zzUint8 indicator_count[4],indicator_i;
extern zzSint32 indicator_arg[4];
extern zzSint32 indicator_x[4],indicator_y[4],indicator_z[4];

extern zzUint8 player_proxy[9][9];

//Fields of Prophert (_type 0=> sprite)
extern zzUint8  field_ingame[32],field_count[32],field_index[32],field_frame[32],field_type[32];
extern zzSint32 field_x[32],field_y[32],field_z[32],field_ix[32],field_iy[32],field_iz[32],field_tx[32],field_ty[32],field_tz[32];
extern zzSint32 field_w[32],field_iw[32];
//Sprites

//Loot
extern zzSint32 loot_x[16],loot_y[16],loot_z[16],loot_x0[16],loot_y0[16],loot_z0[16];
extern zzSint32 loot_rx[16],loot_ry[16],loot_rz[16];
extern zzSint16 loot_count[16];
extern zzUint8 loot_item[16],loot_itemcount[16];

//Player
extern zzUint8 handsword,handpistol;

extern zzSint8 danger_status,ldanger_status;
extern zzUint32 iGameTime;
extern zzSint32 exp_bonus,exp_count;
//extern zzUint8 skill;
extern zzUint8 chmenu_x,chmenu_y[4];
extern zzUint8 lvlclass[4],ch_level,ch_class;
extern zzSint32 ch_exp;
extern zzSint32 exp_lvl[99];
extern zzUint16 item_c[64],item_p[64];
extern zzUint8 skill_l[32],skill_p[32];
extern zzUint8 player_arm[3];

//LEVEL
extern zzSint8 meshxdisplace[131072];
extern zzSint8 meshydisplace[131072];
extern zzSint8 meshzdisplace[131072];

extern zzUint8 blockmapstarus[256];

extern zzUint8 fogcolor,param,levelmusictrack,maxmonsters,counttextureanimation,tiledata_animated[256],tiledata_finalbreak[256],tiledata_breakable[256],tiledata_alpha[256],tiledata_block[256],tiledata_sound[256];
extern zzUint8 levelwarmusictrack;
extern zzSint32 fogrange0,fogrange1;
extern zzSint8 CurrentLevel,LoadedLevel;
extern zzUint8 levelx,levely,levelz,levelsight,triggers,movies;

extern zzSint32 meshx[131072],meshy[131072],meshz[131072];
extern zzUint8 map[131072],mapt0[131072],mapt1[131072],mapt2[131072],mapt3[131072],mapt4[131072],mapt5[131072];
extern zzUint8 mapcam0[131072],mapcam1[131072],mapcam2[131072],mapcam3[131072],mapai[131072],mapobj[131072];
extern zzUint8 staticcams;
extern zzSint32 staticcam[128][6];
extern zzUint8 level_tag;
extern zzUint8 trig[512];
extern char new_message[64];
extern zzUint8 movie_mode,lmovie_mode;
extern zzUint8 lastcamdelay,MonsterHpMode;

//video background
extern zzUint8 GloomHazeCount;

extern zzUint8 bng[76800];
extern zzUint8 chbng[76800];

//end of video Bg

extern void LoadLevel(zzUint8 num);
extern void ClearLevel(void);

extern void LoadBNG(void);
extern zzSint32 camerazoom;
