/*
 This file is part of FleshChasmer.

    FleshChasmer is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FleshChasmer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FleshChasmer.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "sound.h"
#include <SDL/SDL_mixer.h>
#include "globalvar.h"
#include "gpu.h"
#include "zmath.h"
zzUint8 s_channel=1;
zzUint8 lastmusicvolume;


//zzUint8 sound_cashe_i[4];
//zzSint32 sound_cashe_count[4];

void sPlaySound(unsigned int index,unsigned short int left,unsigned short int right)
{
    zzUint8 t=right;

//for (zzUint8 i=1;i<4;i++)
//if ((index!=sound_cashe_i[i])|((count!=sound_cashe_count[i])))
//{
    s_channel++;
    if (s_channel==3) s_channel=1;

    switch (SoundMode)
    {
    case 0://NORMAL
        break;
    case 1://REVERSED
        right=left;
        left=t;
        break;
    case 2://MONO
        if (left>right) right=left;
        else left=right;
        break;
    }

//sound_cashe_i[s_channel]=index;
//sound_cashe_count[s_channel]=count;
    Mix_PlayChannel(s_channel,d_sound[index],0);
#ifdef GP2X
    Mix_SetPanning(s_channel,right,left);
#else
    Mix_SetPanning(s_channel,left,right);
#endif
//}

}
void sPlaySound3D(zzSint32 sx,zzSint32 sy,zzSint32 sz,zzUint8 i_sound,zzSint32 i_range)
{
    zzSint32 px,pz,vv;
    zzSint32 v0,v1;
    zlpoint(sx,sy,sz);
    px=-160+2*vbufferx[zlvertex];
    pz=fastrange(rcamera[2]-sz,rcamera[0]-sx);


    if (pz>0)
        if ((px>-300)&(px<300))
            if ((pz<i_range))
            {
                if (pz>i_range)
                {
                    v0=0;
                    v1=0;
                }
                else
                {
                    v0=128;
                    v1=128;

                    if (px<-20) v1+=(px+20)>>1;
                    else if (px>20) v0-=(px-20)>>1;


                    vv=(64*pz/i_range);
                    if (vv>0) {
                        v0-=vv;
                        v1-=vv;
                    }
                }

                if (v0<48) v0=0;
                if (v1<48) v1=0;
                sPlaySound(i_sound,v0,v1);

            }
            else
            {
                v0=0;
                v1=0;
            }


}
char trackpath[128];
void OpenMusicTrack(unsigned short int track)
{
    Mix_HaltChannel(0);
    if (track<50)
    {
//music[track] = NULL;
        sprintf(trackpath,"data/Track%i%i.ogg",track/10,track%10);
        music=Mix_LoadMUS(trackpath);
        Mix_PlayMusic(music, -1);
//Mix_PlayChannel(0,music[track],256);
    }
}

void SetMusic(unsigned short int track)
{
    OpenMusicTrack(track);
    Music_Volume=70;
    Music_Fade_Count=0;
    zzSint16 vol=(Music_Volume*volume)/128;
    Mix_Volume(0,vol);
    Next_Music_Track=track;
};
void NextMusicTrack(unsigned short int track)
{

    if (Music_Track!=track)
    {

        Next_Music_Track=track;
        Music_Fade_Count=50;
    }
}

void ProcSound(void)
{

    if (Music_Fade_Count)
    {

        if (Music_Fade_Count==25)

        {

            OpenMusicTrack(Next_Music_Track);
            Music_Track=Next_Music_Track;
            trackname_delay=30;
        };
        zzUint32 vol;
        Music_Fade_Count--;

        if (Music_Fade_Count>25) vol=(Music_Fade_Count-25)*4;
        else
            vol=100-Music_Fade_Count*4;
        vol=(vol*volume)/128;
        vol=(vol*Music_Volume)/100;
        Music_Volume_Mix=vol;
        Mix_Volume(0,vol);
        lastmusicvolume=Music_Volume;
    }
    else
    {
        if (lastmusicvolume!=Music_Volume)
        {
            Music_Fade_Count=1;
        }
        lastmusicvolume=Music_Volume;
    }
}

        if (Music_Fade_Count==25)

        {

            OpenMusicTrack(Next_Music_Track);
            Music_Track=Next_Music_Track;
            trackname_delay=30;
        };
        zzUint32 vol;
        Music_Fade_Count--;

        if (Music_Fade_Count>25) vol=(Music_Fade_Count-25)*4;
        else
            vol=100-Music_Fade_Count*4;
        vol=(vol*volume)/128;
        vol=(vol*Music_Volume)/100;
        Music_Volume_Mix=vol;
        Mix_Volume(0,vol);
        lastmusicvolume=Music_Volume;
   
